<i18n>
{
  "fr": {
    "label-1": "Nom du scénario",
    "label-2": "Selectionnez un BGES",
    "label-3": "Selectionnez des variables",
    "save-msg": "Les informations du scénario ont été sauvegardées avec <strong><span style='color:green;'>succès</span></strong>."
  },
  "en": {
    "label-1": "Scenario name",
    "label-2": "Select a GHGI",
    "label-3": "Select variables",
    "save-msg": "The data relating to the scenario have been <strong><span style='color:green;'>successfully</span></strong>saved."
  }
}
</i18n>

<template>
  <div>
    <b-notification :closable="false">
      <div class="columns">
        <div class="column is-3">
          <b-field
            :label="$t('label-1')"
          >
            <b-input
              :placeholder="$t('label-1')"
              v-model="name"
            />
          </b-field>
        </div>
        <div class="column is-3">
          <b-field
            :label="$t('label-2')"
          >
            <b-select
              expanded
              icon="thermometer"
              :placeholder="$t('label-2')"
              v-model="selectedYear"
              @input="compute"
            >
              <option
                v-for="(year,index) in allGHGIYears"
                :value="year"
                :key="index">
                {{ year }}
              </option>
            </b-select>
          </b-field>
        </div>
        <div class="column">
          <b-field
            :label="$t('label-3')"
          >
            <b-taginput
              name="variables"
              icon="caret-right"
              :data="filteredVariables"
              :placeholder="$t('label-3')"
              :allow-new="false"
              field="name"
              rounded
              v-model="selectedVariables"
              :open-on-focus="true"
              @typing="getFilteredVariables"
              @input="compute"
              autocomplete
            />
          </b-field>
        </div>
      </div>
    </b-notification>
    <div class="columns">
      <div class="column is-8">
        <div class="columns">
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p class="heading">
                    {{ ghgiYear }}
                  </p>
                  <div class="title is-size-4">
                    <p>
                      {{ totalGHGI | splitNumberTons }}
                      <span class="is-size-6">{{ $t('t.co2e') }}</span>
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p class="heading">
                    {{ scenario.name }}
                  </p>
                  <div class="title is-size-4">
                    <p>
                      {{ totalScenario | splitNumberTons }}
                      <span class="is-size-6">{{ $t('t.co2e') }}</span>
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p class="heading">
                    Réduction
                  </p>
                  <div class="title is-size-4">
                    <p>
                      {{ reductionRate }} %
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
        </div>
        <b-notification
          v-for="(module,index) in moduleVariables"
          :key="index"
          :closable="false"
          :class="'is-' + module"
        >
          <div class="columns is-multiline">
            <div
              v-for="(variable,indexv) in filterVariables(module)"
              :key="indexv"
              class="column is-4"
            >
              <variable
                :data="variable"
                @input="compute"
                @update-level2="updateLevel2"
                @reset-level2="resetLevel2"
              />
            </div>
          </div>
        </b-notification>
      </div>
      <div class="column">
        <!-- <b-field>
          <b-radio-button
              native-value="bar"
              expanded
              type="is-primary"
          >
            <b-icon icon="bar-chart"></b-icon>
            <span>Vue 1</span>
          </b-radio-button>
          <b-radio-button
              expanded
              native-value="line"
          >
            <b-icon icon="line-chart"></b-icon>
            <span>Vue 2</span>
          </b-radio-button>
          <b-radio-button
              expanded
              native-value="line"
          >
            <b-icon icon="line-chart"></b-icon>
            <span>Vue 3</span>
          </b-radio-button>
        </b-field> -->
        <trajectory-chart
          ref="trajectoryChart"
          :ghgi="selectedGHGI"
          :scenario="scenario"
          :withContrails="withContrails"
        />
      </div>
    </div>
    <logging :scenario="scenario" />
    <vue-editor
      :editor-toolbar="toolbar"
      v-model="description"
    />
    <br />
    <nav class="level">
      <div class="level-left"></div>
      <div class="level-right">
        <div class="buttons">
          <b-button
            class="level-item"
            icon-left="save"
            type="is-primary"
            @click="save"
          >
            {{ $t('save') }}
          </b-button>
        </div>
      </div>
    </nav>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import { VueEditor } from 'vue2-editor'
import Variable from '@/models/scenario/Variable.js'

/* function addPointsBetween (twoPoints) {
  const newPoint = (twoPoints[0] + twoPoints[1]) / 2
  const threePoints = [twoPoints[0], newPoint, twoPoints[1]]
  return threePoints
} */

export default {
  name: 'TrajectoryEditor',
  props: {
    withContrails: {
      type: Boolean,
      default: true
    }
  },
  components: {
    'variable': () => import('@/components/scenario/Variable.vue'),
    'trajectory-chart': () => import('@/components/scenario/TrajectoryChart.vue'),
    'logging': () => import('@/components/scenario/Logging.vue'),
    'vue-editor': VueEditor
  },
  data () {
    return {
      filteredVariables: Variable.getVariables(),
      allVariables: Variable.getVariables(),
      selectedYear: null,
      selectedVariables: [],
      toolbar: [
        ['bold', 'italic', 'underline', 'strike'],
        [{ 'color': [] }, { 'background': [] }],
        [{ list: 'ordered' }, { list: 'bullet' }],
        [{ 'indent': '-1' }, { 'indent': '+1' }],
        ['blockquote', 'code-block'],
        ['link', 'image'],
        ['clean']
      ]
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    allGHGI: function () {
      return this.$store.getters['admin/allGHGI']
    },
    scenario: function () {
      return this.$store.getters['scenario/item']
    },
    uuid: function () {
      return this.$route.params.uuid
    },
    name: {
      get: function () {
        return this.scenario.name
      },
      set: function (name) {
        this.$store.commit('scenario/SET_NAME', name)
      }
    },
    description: {
      get: function () {
        return this.scenario.description
      },
      set: function (description) {
        this.$store.commit('scenario/SET_DESCRIPTION', description)
      }
    },
    selectedGHGI: function () {
      if (this.selectedYear) {
        return this.allGHGI.filter(obj => obj.year === this.selectedYear)[0]
      } else {
        return null
      }
    },
    ghgiYear: function () {
      if (this.selectedGHGI) {
        return this.selectedGHGI.year
      } else {
        return '-'
      }
    },
    allGHGIYears: function () {
      return this.allGHGI.map(obj => obj.year)
    },
    moduleVariables: function () {
      return new Set(this.selectedVariables.map(obj => obj.module).sort().reverse())
    },
    totalGHGI: function () {
      let totalGHGI = 0
      if (this.selectedGHGI && this.scenario) {
        for (let key of Object.keys(this.selectedGHGI.emissions)) {
          if (this.withContrails) {
            totalGHGI += this.selectedGHGI.emissions[key].intensity.intensitywc
          } else {
            totalGHGI += this.selectedGHGI.emissions[key].intensity.intensity
          }
        }
      }
      return Math.round(totalGHGI)
    },
    totalScenario: function () {
      let totalScenario = 0
      if (this.selectedGHGI && this.scenario) {
        if (this.scenario.ghgi) {
          for (let key of Object.keys(this.selectedGHGI.emissions)) {
            if (this.withContrails) {
              totalScenario += this.scenario['ghgi'].emissions[key].intensity.intensitywc
            } else {
              totalScenario += this.scenario['ghgi'].emissions[key].intensity.intensity
            }
          }
        }
      }
      return totalScenario
    },
    reductionRate: function () {
      return Math.round((100 - (this.totalScenario * 100 / this.totalGHGI)) * 10) / 10
    }
  },
  methods: {
    save () {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('scenario/save', this.selectedGHGI.id)
        .then((response) => {
          loadingComponent.close()
          window.scrollTo(0, 0)
          this.$buefy.toast.open({
            type: 'is-light',
            message: this.$t('save-msg')
          })
          this.$router.push('/scenario-1point5/' + response.uuid).catch(() => {})
        })
    },
    updateLevel2 (value) {
      this.$store.dispatch('scenario/setLevel2', value)
      this.$store.dispatch('scenario/compute', this.selectedGHGI)
      this.$refs.trajectoryChart.updateChartsOptions()
      this.compute()
    },
    resetLevel2 (value) {
      this.$store.dispatch('scenario/resetLevel2', value)
      this.$store.dispatch('scenario/compute', this.selectedGHGI)
      this.$refs.trajectoryChart.updateChartsOptions()
      this.compute()
    },
    filterVariables (module) {
      return this.selectedVariables.filter(obj => obj.module === module)
    },
    compute () {
      this.$store.dispatch('scenario/setGHGI', this.selectedGHGI)
      this.$store.dispatch('scenario/setVariables', this.selectedVariables)
      this.$store.dispatch('scenario/compute')
      if (this.$refs.trajectoryChart !== undefined) {
        this.$refs.trajectoryChart.updateChartsOptions()
      }
    },
    del (variable) {
      let index = this.selectedVariables.findIndex(obj => obj.name === variable.name)
      this.selectedVariables.splice(index, 1)
      this.compute()
    },
    getFilteredVariables (text) {
      this.filteredVariables = this.allVariables.filter((option) => {
        return option.name
          .toString()
          .toLowerCase()
          .indexOf(text.toLowerCase()) >= 0
      })
    }
  },
  mounted () {
    if (this.uuid) {
      this.selectedYear = this.allGHGI.filter(obj => obj.id === this.scenario.ghgi.id)[0].year
      this.selectedVariables = this.scenario.variables
      this.compute()
    } else if (this.allGHGI.length > 0) {
      this.selectedYear = this.allGHGI[0].annee
      this.compute()
    }
  }
}
</script>

<style scoped>
.notification.is-heating {
  background-color: rgba(200, 72, 150, .1) !important;
}
.notification.is-electricity {
  background-color: rgba(232, 139, 195, .1) !important;
}
.notification.is-refrigerants {
  background-color: rgba(253, 194, 229, .1) !important;
}
.notification.is-vehicles {
  background-color: rgba(253, 142, 98, .1) !important;
}
.notification.is-travels {
  background-color: rgba(103, 195, 165, .1) !important;
}
.notification.is-commutes {
  background-color: rgba(142, 160, 204, .1) !important;
}
.notification.is-computerdevices {
  background-color: rgba(166, 217, 83, .1) !important;
}
.notification.is-purchases {
  background-color: rgba(255, 218, 44, .1) !important;
}
</style>
